
// Conditional use in node and the browser
if (typeof process == 'object') {
	// Node
	var fs = require('fs');
	var pdfkit = require('pdfkit');
	var pdf = new pdfkit;

	pdf.pipe(fs.createWriteStream('scale-node.pdf'));

	draw(pdf);
} else {
	// Browser
	var pdf = new PDFDocument;
	var stream = pdf.pipe(blobStream());

	draw(pdf);

	stream.on('finish', () => {
		var blob = stream.toBlob('application/pdf');
		var reader = new FileReader();
		reader.readAsDataURL(blob);
		reader.onloadend = function() {
			var b64 = reader.result;
			var a = document.createElement('a');
			a.download = 'scale-browser.pdf';
			a.href = b64;
			a.innerHTML = 'Click Here to Download';

			document.body.insertBefore(a, document.getElementById('insert-here'));
		}
	});
}

function draw(doc) {
	var x = 40, y = 40;

	// Normal
	doc.save()
		.translate(x, y);
	barcode(doc);
	doc.restore();

	// Scale 50%
	y += 40;
	doc.save()
		.scale(0.5)
		.translate(x*2, y*2);
	barcode(doc);
	doc.restore();

	// Scale 1x, 2x
	y += 40;
	doc.save()
		.scale(1, 2)
		.translate(x, y/2);
	barcode(doc);
	doc.restore();

	// Scale 3x, 1x
	y += 80;
	doc.save()
		.scale(3, 1)
		.translate(x/3, y);
	barcode(doc);
	doc.restore();

	doc.end();
}

function barcode(doc) {
	doc.lineWidth(1.85)
		.moveTo(1.5, 35.0)
		.lineTo(1.5, 1.0)
		.stroke()
		.lineWidth(0.85)
		.moveTo(4.0, 35.0)
		.lineTo(4.0, 1.0)
		.stroke()
		.lineWidth(2.85)
		.moveTo(8.0, 35.0)
		.lineTo(8.0, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(12.5, 35.0)
		.lineTo(12.5, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(16.5, 35.0)
		.lineTo(16.5, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(19.5, 35.0)
		.lineTo(19.5, 1.0)
		.stroke()
		.lineWidth(2.85)
		.moveTo(24.0, 35.0)
		.lineTo(24.0, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(27.5, 35.0)
		.lineTo(27.5, 1.0)
		.stroke()
		.lineWidth(2.85)
		.moveTo(31.0, 35.0)
		.lineTo(31.0, 1.0)
		.stroke()
		.lineWidth(0.85)
		.moveTo(34.0, 35.0)
		.lineTo(34.0, 1.0)
		.stroke()
		.lineWidth(2.85)
		.moveTo(37.0, 35.0)
		.lineTo(37.0, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(40.5, 35.0)
		.lineTo(40.5, 1.0)
		.stroke()
		.lineWidth(0.85)
		.moveTo(45.0, 35.0)
		.lineTo(45.0, 1.0)
		.stroke()
		.lineWidth(0.85)
		.moveTo(50.0, 35.0)
		.lineTo(50.0, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(52.5, 35.0)
		.lineTo(52.5, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(56.5, 35.0)
		.lineTo(56.5, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(59.5, 35.0)
		.lineTo(59.5, 1.0)
		.stroke()
		.lineWidth(3.85)
		.moveTo(63.5, 35.0)
		.lineTo(63.5, 1.0)
		.stroke()
		.lineWidth(0.85)
		.moveTo(67.0, 35.0)
		.lineTo(67.0, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(72.5, 35.0)
		.lineTo(72.5, 1.0)
		.stroke()
		.lineWidth(0.85)
		.moveTo(75.0, 35.0)
		.lineTo(75.0, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(78.5, 35.0)
		.lineTo(78.5, 1.0)
		.stroke()
		.lineWidth(2.85)
		.moveTo(84.0, 35.0)
		.lineTo(84.0, 1.0)
		.stroke()
		.lineWidth(0.85)
		.moveTo(87.0, 35.0)
		.lineTo(87.0, 1.0)
		.stroke()
		.lineWidth(1.85)
		.moveTo(89.5, 35.0)
		.lineTo(89.5, 1.0)
		.stroke()
		;
}
